<?php
namespace FrontEndUsers;
use \feu_utils;

abstract class verification_assistant
{
    protected $feu;
    private $_destpage;

    public function __construct( \FrontEndUsers $mod )
    {
        $this->feu = $mod;
    }
    
    private function generate_destpage($uid)
    {
        $dflt = \ContentOperations::get_instance()->GetDefaultContent();
        $page = feu_utils::resolve_preftpl_to_page('pageid_onverify',$uid);
        if( !$page ) $page = $dflt;
        return $page;
    }

    public function get_destpage()
    {
        return $this->_destpage;
    }

    public function set_destpage($str)
    {
        if( $str ) {
            $this->_destpage = $this->feu->resolve_alias_or_id($str,$this->_destpage);
        }
    }

    public function set_force_verify( $uid, $flag = true )
    {
        $uid = (int) $uid;
        if( $uid < 1 ) throw new \InvalidArgumentException( 'Invalid uid passed to '.__METHOD__);
        
        if( $flag ) {
            $code = feu_utils::generate_random_printable_string();
            $this->feu->SetUserTempCode( $uid, $code );
            $this->feu->ForceVerify( $uid, TRUE );
            return $code;
        }
        else {
            $this->feu->RemoveUserTempCode( $uid );
            $this->feu->ForceVerify( $uid, FALSE );
        }
    }
    
    public function get_verify_form_url($uid, $code = null )
    {
        $uid = (int) $uid;
        if( $uid < 1 ) throw new \InvalidArgumentException( 'Invalid uid passed to '.__METHOD__);
        $code = trim($code);
        if( !$code ) $code = 'xxxx';
        
        $destpage = $this->_destpage;
        if( !$destpage ) $destpage = $this->generate_destpage($uid);
        $url = $this->feu->create_url('cntnt01','verifyonly',$destpage,[ 'uid'=>$uid, 'code'=>$code ] );
        $url = str_replace( 'amp;', '', $url );
        return $url;
    }

    abstract public function send( $uid, $code );
    
}
